﻿Public Class Form1
    Private mainGraphics As Graphics
    Private PlayerImage As Bitmap
    Dim Random As New Random

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Init()
        Timer1.Enabled = True
    End Sub
    Private Sub Init()

        '▼描画用のGraphicsクラスの確保(技術的な処理)
        If mainGraphics Is Nothing Then
            '初回のみ生成
            Dim bmp As New Bitmap(Me.ClientRectangle.Width, Me.ClientRectangle.Height)
            Me.BackgroundImage = bmp
            mainGraphics = Graphics.FromImage(bmp)
        End If

        'exeと同じフォルダーにあるPlayer1.bmpを読み込む。
        'これができるのは、ファイルのプロパティで出力ディレクトリにコピーする設定になっているから。
        PlayerImage = Image.FromFile(Application.StartupPath & "\Player1.bmp")

        ZakoImage = Image.FromFile(Application.StartupPath & "\Zako1.bmp")

        x = (Me.ClientSize.Width - 64) \ 2
        y = Me.ClientSize.Height - 64

    End Sub

    Dim x As Integer
    Dim y As Integer
    Dim ZakoImage As Bitmap
    Dim zako1X As Integer
    Dim zako1Y As Integer = -64
    Dim IsZako1Alive As Boolean = True
    Dim zako2X As Integer
    Dim zako2Y As Integer = -64
    Dim IsZako2Alive As Boolean = False

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        '描画されているものを消して全面を黒くする。
        mainGraphics.Clear(Color.Black)

        If IsRight Then
            x += 1
        End If

        If IsLeft Then
            x -= 1
        End If

        If IsUp Then
            y -= 1
        End If

        If IsDown Then
            y += 1
        End If

        mainGraphics.DrawImage(PlayerImage, x, y)

     
        '▼１体目の敵
        If IsZako1Alive Then
            If zako1Y = -64 Then
                zako1X = Random.Next(0, Me.ClientSize.Width - 64 + 1)
            End If
            zako1Y += 2
            mainGraphics.DrawImage(ZakoImage, zako1X, zako1Y)

            '敵のY座標がフォームの高さより多くなったとき(=敵が画面の外に出たとき)
            '敵は消滅する。
            If zako1Y > Me.ClientSize.Height Then
                IsZako1Alive = False
            End If
        Else

            If Random.Next(0, 1000) < 10 Then
                zako1Y = -64
                IsZako1Alive = True
            End If

        End If

        '▼２体目の敵
        If IsZako2Alive Then
            If zako2Y = -64 Then
                zako2X = Random.Next(0, Me.ClientSize.Width - 64 + 1)
            End If
            zako2Y += 2
            mainGraphics.DrawImage(ZakoImage, zako2X, zako2Y)

            '敵のY座標がフォームの高さより多くなったとき(=敵が画面の外に出たとき)
            '敵は消滅する。
            If zako2Y > Me.ClientSize.Height Then
                IsZako2Alive = False
            End If

        Else

            If Random.Next(0, 1000) < 10 Then
                zako2Y = -64
                IsZako2Alive = True
            End If

        End If

        'デバッグ用にzako1Yの値を左上に表示する。
        mainGraphics.DrawString(zako1Y.ToString, Me.Font, Brushes.LightGreen, New Point(0, 0))

        'フォームを再描画
        Me.Invalidate()

    End Sub

    ''' <summary>右矢印が押されているか</summary>
    Dim IsRight As Boolean
    ''' <summary>左矢印が押されているか</summary>
    Dim IsLeft As Boolean
    ''' <summary>上矢印が押されているか</summary>
    Dim IsUp As Boolean
    ''' <summary>下矢印が押されているか</summary>
    Dim IsDown As Boolean

    Private Sub Form1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown

        Select Case e.KeyCode
            Case Keys.Right
                IsRight = True
            Case Keys.Left
                IsLeft = True
            Case Keys.Up
                IsUp = True
            Case Keys.Down
                IsDown = True
        End Select

    End Sub

    Private Sub Form1_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp

        Select Case e.KeyCode
            Case Keys.Right
                IsRight = False
            Case Keys.Left
                IsLeft = False
            Case Keys.Up
                IsUp = False
            Case Keys.Down
                IsDown = False
        End Select

    End Sub


End Class
